 clear all; close all;

data_MR  = xlsread('SOI_Marginal_Rates_by_AGI_and_FS.xlsx','ALLYEARS');
MR.DAT   = data_MR(:,6:end);
MR.year  = data_MR(:,1);
MR.fs    = data_MR(:,3);   % Filing Status   1:ALL      2:SINGLE      3:MFJ       4:MFS       5:HOH      36: MFJ+SURV    24: MFS+SINGLE
MR.var   = data_MR(:,5);   % Variable        1:BRACKET  2: MARG RATE  3:TAXTYPE   4:NUMBER OF RETURNS   5:AGI    6: SURCHARGE    

YEARS = (min(MR.year):max(MR.year))';            

data_U   = xlsread('SOI_Marginal_Rates_by_AGI_and_FS.xlsx','TAX UNITS'); 

sel=(data_U(:,1)>=min(YEARS))&(data_U(:,1)<=max(YEARS));
TAXUNITS = data_U(sel,2)*1000;

load D 

quan = [0 0.99 0.95 0.90];
AGIFLOORS = fun_AGIFLOORS(quan,D,YEARS,TAXUNITS);

AMTR         = zeros(length(YEARS),length(quan));
TAGI         = zeros(length(YEARS),length(quan));
TOTAGI       = zeros(length(YEARS),1);
TRET         = zeros(length(YEARS),1);

for year = [YEARS(1)-min(YEARS)+1:1978-min(YEARS)+1 2003-min(YEARS)+1:YEARS(end)-min(YEARS)+1];    
    
        select_year = (MR.year==year+min(YEARS)-1);
        DAT         =  MR.DAT(select_year,:);
        FS          =  MR.fs(select_year,1);
        VAR         =  MR.var(select_year,1);
       
        for fs = [2:6]; % Missing 7 
            
            if  isempty(D{year,fs,1}.avagi)==0
                
             [tbra,smtr,DD] = fun_selectS(fs,year,DAT,FS,VAR,YEARS,D);  
  
             % Numerically Integrate               
             bra_floor = sort(unique([exp(linspace(log(DD.bra(2,1)), log(DD.bra(sum(DD.avti<max(tbra)),2)),1000)'); DD.bra(:,1);AGIFLOORS(year,2:end)']));
             bra_ceil  = [bra_floor(2:end);DD.bra(end,2)];            
             BRA = [bra_floor bra_ceil];
             DD  = fun_NewBrackets(BRA,DD);
            
             yt = DD.avti;
             yy = DD.avagi.*DD.w*DD.TOTRET;             
             pos  = sum((yt*ones(1,length(tbra))>=ones(length(yt),1)*tbra),2);            
             mtr    = [0 smtr(pos)];
             allagi = [D{year,fs,1}.TOTAGI-sum(yy) yy'];

             AMTR(year,1)  = AMTR(year,1)*TAGI(year,1)/(TAGI(year,1)+sum(allagi))+(mtr*allagi')/(TAGI(year,1)+sum(allagi));
             TAGI(year,1)  = TAGI(year,1)+sum(allagi);
             TRET(year,1)  = TRET(year,1)+D{year,fs,1}.TOTRET;
             
             for j = 2:length(quan);
                     sel_agi       = [0 ;DD.bra(:,1)>=AGIFLOORS(year,j)];
                     mtrQ          = mtr(sel_agi'==1);
                     allagiQ       = allagi(sel_agi'==1);

                     AMTR(year,j) = AMTR(year,j)*TAGI(year,j)/(TAGI(year,j)+sum(allagiQ))+(mtrQ*allagiQ')/(TAGI(year,j)+sum(allagiQ));
                     TAGI(year,j) = TAGI(year,j)+sum(allagiQ);
             end 
            end
             
        end 
             TOTAGI(year,1) = D{year,1,1}.TOTAGI;
             AMTR(year,1)   = AMTR(year,1)*TAGI(year,1)/(TAGI(year,1)+0.20*D{year,1,1}.TOTAGI./D{year,1,1}.TOTRET*(TAXUNITS(year,1)-D{year,1,1}.TOTRET));

end

AMTR(AMTR==0)=NaN;
TAGI(TAGI==0)=NaN;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
AMTR_all = AMTR(:,1);

AMTR_top = AMTR(:,2:4);
TAGI_top = TAGI(:,2:4);
nn= ones(1,size(AMTR_top,2));

MTRS2  = [YEARS AMTR_all AMTR_top];

%AMTR_bottom = (AMTR_all*nn).*(TOTAGI*nn./(TOTAGI*nn-TAGI_top))-AMTR_top.*(TAGI_top./(TOTAGI*nn-TAGI_top));

% AMTR_10to5   = (AMTR_all-(TOTAGI-TAGI(:,3))./TOTAGI.*AMTR_bottom(:,2)-TAGI(:,4)./TOTAGI.*AMTR(:,4)).*TOTAGI./(TOTAGI-(TOTAGI-TAGI(:,3))-TAGI(:,4));
% AMTR_5to1    = (AMTR_all-(TOTAGI-TAGI(:,4))./TOTAGI.*AMTR_bottom(:,3)-TAGI(:,2)./TOTAGI.*AMTR(:,2)).*TOTAGI./(TOTAGI-(TOTAGI-TAGI(:,4))-TAGI(:,2));

%AMTR_10to5   = (AMTR(:,3)).*(TAGI(:,3)./(TAGI(:,3)-TAGI(:,4)))-AMTR(:,4).*(TAGI(:,4)./(TAGI(:,3)-TAGI(:,4)));
%AMTR_5to1    = (AMTR(:,4)).*(TAGI(:,4)./(TAGI(:,4)-TAGI(:,2)))-AMTR(:,2).*(TAGI(:,2)./(TAGI(:,4)-TAGI(:,2)));


%MTRS2  = [YEARS AMTR_all AMTR_top(:,1:2) AMTR_bottom(:,1:2) AMTR_10to5 AMTR_5to1 AMTR(:,4)];
save('MTRS2','MTRS2');


